
(function(exports){var downloadsContainer=null;var emptyDownloadsContainer=null;var downloadsPanel=null;var downloadsEditMenu=null;var editButton=null;var editHeader=null;var deleteButton=null;var selectAllButton=null;var deselectAllButton=null;var isEditMode=false;var numberOfDownloads=0;var numberOfCheckedDownloads=0;function _checkEmptyList(){if(!downloadsContainer){return;}
var isEmpty=(downloadsContainer.children.length===0);if(isEmpty){downloadsContainer.hidden=true;emptyDownloadsContainer.hidden=false;}else{downloadsContainer.hidden=false;emptyDownloadsContainer.hidden=true;}
editButton.disabled=isEmpty;}
function _newDownload(download){_prepend(download).then(()=>{if(isEditMode){numberOfDownloads++;_updateButtonsStatus();}});}
function _render(downloads,oncomplete){if(!downloadsContainer){return;}
if(!downloads||downloads.length===0){_checkEmptyList();return;}
downloadsContainer.innerHTML='';Promise.all(downloads.map(_append)).then(()=>{oncomplete&&oncomplete();});}
function _onerror(){console.error('Error while retrieving');}
function _create(download){return DownloadItem.create(download).then((li)=>{if(download.state==='downloading'){download.onstatechange=_onDownloadStateChange;}
li.addEventListener('click',_onDownloadAction);return li;});}
function _prepend(download){if(downloadsContainer.children.length===0){_append(download).then(()=>{_checkEmptyList();});return;}
_create(download).then((li)=>{downloadsContainer.insertBefore(li,downloadsContainer.firstChild);_checkEmptyList();});}
function _append(download){return _create(download).then((li)=>{downloadsContainer.appendChild(li);});}
function _getElementForId(id){return downloadsContainer.querySelector('[data-id="'+id+'"]');}
function _update(download){var id=DownloadItem.getDownloadId(download);var elementToUpdate=_getElementForId(id);if(!elementToUpdate){console.error('Item to update not found');return;}
DownloadItem.refresh(elementToUpdate,download);DownloadApiManager.updateDownload(download);}
function _onDownloadAction(event){if(isEditMode){return;}
var downloadID=event.target.id||event.target.dataset.id;var download=DownloadApiManager.getDownload(downloadID);_actionHandler(download);}
function _onDownloadStateChange(event){var download=event.download;if(download.state==='finalized'){return;}
_update(download);}
function _actionHandler(download){if(!download){console.error('Download not retrieved properly');return;}
switch(download.state){case'downloading':_pauseDownload(download);break;case'stopped':_restartDownload(download);break;case'finalized':case'succeeded':_showDownloadActions(download);break;}}
function _pauseDownload(download){var request=DownloadUI.show(DownloadUI.TYPE.STOP,download);request.onconfirm=function(){if(download.pause){download.pause().then(function(){_update(download);},function(){console.error('Could not pause the download');});}};}
function _restartDownload(download){var request=DownloadUI.show(null,download);request.onconfirm=function(){if(download.resume){download.resume().then(function(){},function onError(){navigator.mozL10n.formatValue('restart_download_error').then(msg=>console.error(msg));});}};}
function _showDownloadActions(download){var actionReq=DownloadUI.showActions(download);actionReq.onconfirm=function(evt){var req=DownloadHelper[actionReq.result.name](download);req.onerror=function(){DownloadHelper.handlerError(req.error,download,function removed(d){if(!d){return;}
var downloadId=DownloadItem.getDownloadId(d);var elementToDelete=_getElementForId(downloadId);DownloadApiManager.deleteDownloads([{id:downloadId,force:true}],function onDeleted(){_removeDownloadsFromUI([elementToDelete]);_checkEmptyList();},function onError(){console.warn('Download not removed during launching');});});};};}
function _getAllChecks(){return downloadsContainer.querySelectorAll('gaia-checkbox');}
function _getAllChecked(){return[].filter.call(_getAllChecks(),el=>{return el.checked;});}
function _markAllChecksAs(condition){var checks=_getAllChecks();for(var i=0;i<checks.length;i++){checks[i].checked=condition;}
numberOfCheckedDownloads=condition?numberOfDownloads:0;}
function _enableAllChecks(){_markAllChecksAs(true);_updateButtonsStatus();}
function _disableAllChecks(){_markAllChecksAs(false);_updateButtonsStatus();}
function _updateButtonsStatus(){if(numberOfDownloads===0){numberOfDownloads=_getAllChecks().length;}
deleteButton.disabled=(numberOfCheckedDownloads<=0);selectAllButton.disabled=(numberOfCheckedDownloads===numberOfDownloads);deselectAllButton.disabled=(numberOfCheckedDownloads===0);}
function _onDownloadSelected(event){if(isEditMode&&event.target.tagName==='LI'){var input=event.target.querySelector('gaia-checkbox');if(typeof input==='undefined'){return;}
var checked=input.checked=!input.checked;checked?numberOfCheckedDownloads++:numberOfCheckedDownloads--;_updateButtonsStatus();}}
function _deleteDownloads(){var downloadsChecked=_getAllChecked()||[];var downloadItems=[],downloadElements={};var downloadList=[];var total=downloadsChecked.length;var multipleDelete=total>1;for(var i=0;i<total;i++){downloadItems.push({id:downloadsChecked[i].value,force:multipleDelete});downloadElements[downloadsChecked[i].value]=downloadsChecked[i].parentNode;if(multipleDelete){downloadList.push(downloadElements[downloadsChecked[i].value]);}}
function deletionDone(){_checkEmptyList();_closeEditMode();}
function doDeleteDownloads(){DownloadApiManager.deleteDownloads(downloadItems,function downloadsDeleted(downloadID){_removeDownloadsFromUI([downloadElements[downloadID]]);},function onError(downloadID,msg){console.warn('Could not delete '+downloadID+' : '+msg);deletionDone();},function onComplete(){deletionDone();});}
if(multipleDelete){var req=DownloadUI.show(DownloadUI.TYPE.DELETE_ALL,downloadList);req.onconfirm=doDeleteDownloads;req.oncancel=deletionDone;}else{doDeleteDownloads();}}
function _removeDownloadsFromUI(elements){for(var i=0;i<elements.length;i++){downloadsContainer.removeChild(elements[i]);}}
function _loadEditMode(){_disableAllChecks();downloadsPanel.classList.add('edit');downloadsEditMenu.hidden=false;isEditMode=true;_updateButtonsStatus();}
function _closeEditMode(){downloadsPanel.classList.remove('edit');downloadsEditMenu.hidden=true;isEditMode=false;numberOfDownloads=0;numberOfCheckedDownloads=0;}
function _downloadApiManagerListener(changeEvent){switch(changeEvent.type){case'added':var element=null;if(changeEvent.downloadApiId&&(element=_getElementForId(changeEvent.downloadApiId))){DownloadItem.updateDownloadId(changeEvent.download,element);}
else if((element=_getElementForId(changeEvent.download.id))){_update(changeEvent.download);}
else{_newDownload(changeEvent.download);}
break;}}
var DownloadsList={init:function(oncomplete){var scripts=['shared/js/download/download_store.js','shared/js/download/download_ui.js','shared/js/mime_mapper.js','shared/js/download/download_helper.js','shared/js/download/download_formatter.js','js/downloads/download_api_manager.js','js/downloads/download_item.js'];if(!navigator.mozDownloadManager){scripts.push('js/downloads/desktop/desktop_moz_downloads.js');}
LazyLoader.load(scripts,function onload(){downloadsContainer=document.querySelector('#downloadList ul');emptyDownloadsContainer=document.getElementById('download-list-empty');downloadsPanel=document.getElementById('downloads');downloadsEditMenu=document.getElementById('downloads-edit-menu');editButton=document.getElementById('downloads-edit-button');editHeader=document.getElementById('downloads-edit-header');deleteButton=document.getElementById('downloads-delete-button');selectAllButton=document.getElementById('downloads-edit-select-all');deselectAllButton=document.getElementById('downloads-edit-deselect-all');DownloadApiManager.init();DownloadApiManager.setListener(_downloadApiManagerListener.bind(this));DownloadApiManager.getDownloads(_render.bind(this),_onerror.bind(this),oncomplete);DownloadApiManager.setOnDownloadHandler(_newDownload);editButton.addEventListener('click',_loadEditMode.bind(this));editHeader.addEventListener('action',_closeEditMode.bind(this));selectAllButton.addEventListener('click',_enableAllChecks.bind(this));deselectAllButton.addEventListener('click',_disableAllChecks.bind(this));deleteButton.addEventListener('click',_deleteDownloads.bind(this));downloadsContainer.addEventListener('click',_onDownloadSelected.bind(this));});}};exports.DownloadsList=DownloadsList;}(window));DownloadsList.init();