;'use strict';(function(exports){var UserPress=function(obj,coords){this.target=obj;this.updateCoords(coords,false);this.startTime=Date.now();this.startCoords=coords;this.startTarget=obj;};UserPress.prototype.updateCoords=function(coords,moved){this.moved=moved;this.clientX=coords.clientX;this.clientY=coords.clientY;this.endTime=Date.now();};var UserPressManager=function(app){this._started=false;this._ignoreMouseEvents=false;this.presses=new Map();this.touchstartCounts=new WeakMap();this.app=app;};UserPressManager.prototype.onpressstart=null;UserPressManager.prototype.onpressmove=null;UserPressManager.prototype.onpressend=null;UserPressManager.prototype.MOVE_LIMIT=5;UserPressManager.prototype.MIN_BOGUS_EVENT_DISTANCE=20;UserPressManager.prototype.MIN_BOGUS_EVENT_VELOCITY=0.3;UserPressManager.prototype.start=function(){this.app.console.log('UserPressManager.start()');if(this._started){throw new Error('UserPressManager: '+'Instance should not be start()\'ed twice.');}
this._started=true;this._container=this.app.getContainer();this._container.addEventListener('touchstart',this);this._container.addEventListener('mousedown',this);this._container.addEventListener('contextmenu',this);this._isLowEndDevice=false;this.settings=new UserPressManagerSettings();this.settings.promiseManager=this.app.settingsPromiseManager;this.settings.onsettingchange=this._handleSettingsChange.bind(this);this.settings.initSettings().then(this._handleSettingsChange.bind(this),function rejected(err){console.error('Fatal Error! Failed to get initial '+'targetHandlersManager settings.',err);});};UserPressManager.prototype.stop=function(){this.app.console.log('UserPressManager.stop()');if(!this._started){throw new Error('UserPressManager: '+'Instance was never start()\'ed but stop() is called.');}
this._started=false;this._container.removeEventListener('touchstart',this);this._container.removeEventListener('mousedown',this);this._container.removeEventListener('mousemove',this);this._container.removeEventListener('mouseup',this);this._container.removeEventListener('mouseleave',this);this._container.removeEventListener('contextmenu',this);this.settings=null;};UserPressManager.prototype.handleEvent=function(evt){var touch,touchId,el,i,touchstartCount;switch(evt.type){case'contextmenu':evt.preventDefault();break;case'touchstart':this._ignoreMouseEvents=true;touchstartCount=this.touchstartCounts.get(evt.target)||0;touchstartCount++;this.touchstartCounts.set(evt.target,touchstartCount);evt.target.addEventListener('touchmove',this);evt.target.addEventListener('touchend',this);evt.target.addEventListener('touchcancel',this);for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;el=touch.target;this._handleNewPress(el,touch,touchId);}
break;case'touchmove':for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;if(!this._distanceReachesLimit(touchId,touch)){continue;}
el=document.elementFromPoint(touch.clientX,touch.clientY);this._handleChangedPress(el,touch,touchId);}
break;case'touchend':case'touchcancel':touchstartCount=this.touchstartCounts.get(evt.target);touchstartCount--;if(touchstartCount){this.touchstartCounts.set(evt.target,touchstartCount);}else{evt.target.removeEventListener('touchmove',this);evt.target.removeEventListener('touchend',this);evt.target.removeEventListener('touchcancel',this);this.touchstartCounts.delete(evt.target);}
if(!this._started){return;}
for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;el=document.elementFromPoint(touch.clientX,touch.clientY);this._handleFinishPress(el,touch,touchId);}
break;case'mousedown':evt.preventDefault();if(this._ignoreMouseEvents){return;}
this._container.addEventListener('mousemove',this);this._container.addEventListener('mouseup',this);this._container.addEventListener('mouseleave',this);this._handleNewPress(evt.target,evt,'_mouse');break;case'mousemove':if(!this._distanceReachesLimit('_mouse',evt)){return;}
this._handleChangedPress(evt.target,evt,'_mouse');break;case'mouseup':case'mouseleave':this._container.removeEventListener('mousemove',this);this._container.removeEventListener('mouseup',this);this._container.removeEventListener('mouseleave',this);this._handleFinishPress(evt.target,evt,'_mouse');break;}};UserPressManager.prototype._handleNewPress=function(el,coords,id){this.app.console.info('UserPressManager._handleNewPress()');var press=new UserPress(this.app.layoutRenderingManager.getTargetObject(el),coords);this.presses.set(id,press);if(typeof this.onpressstart==='function'){this.onpressstart(press,id);}};UserPressManager.prototype._handleChangedPress=function(el,coords,id){this.app.console.info('UserPressManager._handleChangedPress()');var press=this.presses.get(id);press.target=this.app.layoutRenderingManager.getTargetObject(el);press.updateCoords(coords,true);if(typeof this.onpressmove==='function'){this.onpressmove(press,id);}};UserPressManager.prototype._handleFinishPress=function(el,coords,id){this.app.console.info('UserPressManager._handleFinishPress()');if(this._isLowEndDevice){this._handleLowEndDeviceFinishPress(el,coords,id);return;}
var press=this.presses.get(id);press.target=this.app.layoutRenderingManager.getTargetObject(el);press.updateCoords(coords,press.moved||this._distanceReachesLimit(id,coords));if(typeof this.onpressend==='function'){this.onpressend(press,id);}
this.presses.delete(id);};UserPressManager.prototype._handleLowEndDeviceFinishPress=function(el,coords,id){this.app.console.info('UserPressManager._handleLowEndDeviceFinishPress()');var press=this.presses.get(id);press.target=this.app.layoutRenderingManager.getTargetObject(el);press.updateCoords(coords,press.moved||this._distanceReachesLimit(id,coords));if(this._exceedSpeedLimit(press)&&press.target.keyCode!==press.startTarget.keyCode){var currentTargetObject=press.target;press.target=press.startTarget;press.updateCoords(press.startCoords,true);if(typeof this.onpressmove==='function'){this.onpressmove(press,id);}
if(typeof this.onpressend==='function'){this.onpressend(press,id);}
this.presses.delete(id);var syntheticPress=new UserPress(currentTargetObject,coords);if(typeof this.onpressstart==='function'){this.onpressstart(syntheticPress,id);}
syntheticPress.updateCoords(coords,false);if(typeof this.onpressend==='function'){this.onpressend(syntheticPress,id);}}else{if(typeof this.onpressend==='function'){this.onpressend(press,id);}
this.presses.delete(id);}};UserPressManager.prototype._exceedSpeedLimit=function(press){var dx=press.startCoords.clientX-press.clientX;var dy=press.startCoords.clientY-press.clientY;if(dx+dy===0){return false;}
var time=press.endTime-press.startTime;var distance=Math.sqrt(dx*dx+dy*dy);if(distance<this.MIN_BOGUS_EVENT_DISTANCE){return false;}
return(distance/time>this.MIN_BOGUS_EVENT_VELOCITY);};UserPressManager.prototype._distanceReachesLimit=function(id,newCoord){var press=this.presses.get(id);var dx=press.clientX-newCoord.clientX;var dy=press.clientY-newCoord.clientY;var limit=this.MOVE_LIMIT;return(dx>=limit||dx<=-limit||dy>=limit||dy<=-limit);};UserPressManager.prototype._handleSettingsChange=function(values){this._isLowEndDevice=values.deviceinfoHardware==='sp8810'||values.deviceinfoHardware==='roamer2'||values.deviceinfoProductModel==='GP-KEON'||values.deviceinfoProductModel==='GoFox F15';};exports.UserPress=UserPress;exports.UserPressManager=UserPressManager;})(window);