
require(['modules/settings_cache','shared/toaster','shared/settings_listener'],function(SettingsCache,Toaster,SettingsListener){const MEDIA_TYPE=['music','pictures','videos','sdcard'];const ITEM_TYPE=['music','pictures','videos','free'];const DEFAULT_MEDIA_VOLUME_KEY='device.storage.writable.name';const EXTERNAL_UNRECOGNISED_KEY='volume.external.unrecognised';const LATENCY_CHECK_STATUS_AFTER_IDLE_IN_MILLISECONDS=600;var Volume=function(name,external,externalIndex,storages){this.name=name;this.external=external;this.isUnrecognised=false;this.externalIndex=externalIndex;this.storages=storages;this.currentStorageStatus=null;this.rootElement=null;this.stackedbar=null;};Volume.prototype.getVolumeId=function volume_getVolumeId(){return(this.external)?'external-'+this.externalIndex:'internal';};Volume.prototype.getL10nId=function volume_getL10nId(useShort){var prefix=useShort?'short-storage-name-':'storage-name-';return prefix+this.getVolumeId();};Volume.prototype.createView=function volume_createView(listRoot){var l10nId,li,label,text,size,anchor,button,buttonType;var h2=document.createElement('h2');l10nId=this.getL10nId();h2.setAttribute('data-l10n-id',l10nId);var header=document.createElement('header');header.appendChild(h2);header.dataset.id=this.getVolumeId();listRoot.appendChild(header);this.rootElement=document.createElement('ul');listRoot.appendChild(this.rootElement);var stackedbarDiv=document.createElement('div');stackedbarDiv.id=this.name+'-space-stackedbar';stackedbarDiv.classList.add('space-stackedbar');li=document.createElement('li');li.appendChild(stackedbarDiv);this.rootElement.appendChild(li);this.stackedbar=StackedBar(stackedbarDiv);var self=this;ITEM_TYPE.forEach(function(type){label=document.createElement('span');label.classList.add('stackedbar-color-label');anchor=document.createElement('a');size=document.createElement('span');size.classList.add('size');size.hidden=true;text=document.createElement('span');l10nId=type+'-space';text.setAttribute('data-l10n-id',l10nId);anchor.appendChild(text);anchor.appendChild(size);li=document.createElement('li');li.classList.add('color-'+type);li.appendChild(label);li.appendChild(anchor);self.rootElement.appendChild(li);});anchor=document.createElement('a');size=document.createElement('span');size.classList.add('size');size.hidden=true;text=document.createElement('span');l10nId='total-space';text.setAttribute('data-l10n-id',l10nId);anchor.appendChild(text);anchor.appendChild(size);li=document.createElement('li');li.classList.add('total-space');li.appendChild(anchor);this.rootElement.appendChild(li);if(this.storages.sdcard.canBeFormatted){buttonType='format-sdcard-'+this.getVolumeId();button=document.createElement('button');button.classList.add('format-btn');button.setAttribute('data-l10n-id',buttonType);button.disabled=true;button.onclick=this.formatSDCard.bind(this);label=document.createElement('label');label.appendChild(button);li=document.createElement('li');li.appendChild(label);this.rootElement.appendChild(li);}
if(this.external&&this.storages.sdcard.canBeMounted){buttonType='eject-sdcard-'+this.getVolumeId();button=document.createElement('button');button.classList.add('eject-btn');button.setAttribute('data-l10n-id',buttonType);button.disabled=true;button.onclick=this.unmountSDCard.bind(this);label=document.createElement('label');label.appendChild(button);li=document.createElement('li');li.classList.add('eject-btn');li.appendChild(label);this.rootElement.appendChild(li);}};Volume.prototype.updateStorageInfo=function volume_updateStorageInfo(){var self=this;this.getStats(function(sizes){self.stackedbar.reset();ITEM_TYPE.forEach(function(type){var element=self.rootElement.querySelector('.color-'+type+' .size');DeviceStorageHelper.showFormatedSize(element,'storageSize',sizes[type]);element.hidden=false;self.stackedbar.add({'type':type,'value':sizes[type]});});self.stackedbar.refreshUI();var element=self.rootElement.querySelector('[data-l10n-id="total-space"] + .size');DeviceStorageHelper.showFormatedSize(element,'storageSize',sizes.sdcard+sizes.free);element.hidden=false;});};Volume.prototype.enableStorageInfo=function volume_enableStorageInfo(enabled){ITEM_TYPE.forEach(function(type){var rule='li[class="color-'+type+'"]';var element=this.rootElement.querySelector(rule);element.setAttribute('aria-disabled',!enabled);}.bind(this));var rule='li[class="total-space"]';var element=this.rootElement.querySelector(rule);element.setAttribute('aria-disabled',!enabled);};Volume.prototype.updateStorageUIState=function volume_updateStorageUIState(enabled,isUnrecognisedEventUpdate){if(this.isFormatting&&!enabled){return;}
if(this.isUnrecognised&&!enabled){return;}
if(isUnrecognisedEventUpdate&&!enabled&&(this.currentStorageStatus==='Mounted')){return;}
if(this.getVolumeId()==='internal'){return;}
var rule='header[data-id='+this.getVolumeId()+']';this.rootElement.parentNode.querySelector(rule).hidden=!enabled;this.rootElement.hidden=!enabled;if(isUnrecognisedEventUpdate){this.rootElement.querySelector('.space-stackedbar').parentNode.hidden=enabled;this.setUnmountSDCardBtnVisible(!enabled);if(enabled){ITEM_TYPE.forEach(function(type){this.rootElement.querySelector('li[class="color-'+type+'"]').hidden=enabled;}.bind(this));this.rootElement.querySelector('li[class="total-space"]').hidden=enabled;}
return;}
ITEM_TYPE.forEach(function(type){this.rootElement.querySelector('li[class="color-'+type+'"]').hidden=!enabled;}.bind(this));this.rootElement.querySelector('li[class="total-space"]').hidden=!enabled;};Volume.prototype.getStats=function volume_getStats(callback){var results={};var current=MEDIA_TYPE.length;var storages=this.storages;MEDIA_TYPE.forEach(function(type){var storage=storages[type];storage.usedSpace().onsuccess=function(e){results[type]=e.target.result;current--;if(current===0){storage.freeSpace().onsuccess=function(e){results.free=e.target.result;if(callback){callback(results);}};}};});};Volume.prototype.updateInfo=function volume_updateInfo(callback){var self=this;var availreq=this.storages.sdcard.available();availreq.onsuccess=function availSuccess(evt){var state=evt.target.result;switch(state){case'shared':self.updateStorageUIState(true);self.setInfoUnavailable();self.enableStorageInfo(false);break;case'unavailable':self.setInfoUnavailable();self.enableStorageInfo(false);self.updateStorageUIState(false);break;case'available':self.updateStorageUIState(true);self.updateStorageInfo();self.enableStorageInfo(true);self.enableUnmountSDCardBtn(true);self.enableFormatSDCardBtn(true);break;}
if(callback){callback(state);}};};Volume.prototype.updateUIState=function volume_updateUIState(storageStatus){switch(storageStatus){case'Init':case'NoMedia':case'Pending':case'Unmounting':this.updateStorageUIState(false);this.enableUnmountSDCardBtn(false);this.enableFormatSDCardBtn(false);break;case'Shared':case'Shared-Mounted':this.updateStorageUIState(true);this.enableUnmountSDCardBtn(false);this.enableFormatSDCardBtn(false);break;case'Formatting':this.enableUnmountSDCardBtn(false);this.enableFormatSDCardBtn(false,true);this.isFormatting=false;break;case'Checking':this.isFormatting=false;break;case'Idle':if(this.isUnmounting){this.isUnmounting=false;var toast={messageL10nId:'sdcardUnmounted',latency:3000,useTransition:true};Toaster.showToast(toast);}
this.updateStorageUIState(false);this.enableUnmountSDCardBtn(false);break;case'Mounted':this.updateStorageUIState(true);this.enableUnmountSDCardBtn(true);this.enableFormatSDCardBtn(true);break;}};Volume.prototype.setInfoUnavailable=function volume_setInfoUnavailable(){var self=this;ITEM_TYPE.forEach(function(type){var rule='.color-'+type+' .size';var element=self.rootElement.querySelector(rule);element.setAttribute('data-l10n-id','size-not-available');});var element=this.rootElement.querySelector('.total-space .size');element.setAttribute('data-l10n-id','size-not-available');this.stackedbar.reset();};Volume.prototype.mountSDCard=function volume_mountSDCard(evt){this.storages.sdcard.mount();};Volume.prototype.unmountSDCard=function volume_unmountSDCard(evt){var popup=document.getElementById('unmount-sdcard-dialog');var cancelBtn=document.getElementById('unmount-sdcard-cancel-btn');var okBtn=document.getElementById('unmount-sdcard-ok-btn');var self=this;var confirmHandler=function(){enablePopup(false);self.storages.sdcard.unmount();self.isUnmounting=true;};var cancelHandler=function(){enablePopup(false);};var enablePopup=function Vf_enablePopup(enabled){if(enabled){okBtn.addEventListener('click',confirmHandler);cancelBtn.addEventListener('click',cancelHandler);popup.hidden=false;}else{okBtn.removeEventListener('click',confirmHandler);cancelBtn.removeEventListener('click',cancelHandler);popup.hidden=true;}};enablePopup(true);};Volume.prototype.formatSDCard=function volume_formatSDCard(evt){var popup=document.getElementById('format-sdcard-dialog');var cancelBtn=document.getElementById('format-sdcard-cancel-btn');var okBtn=document.getElementById('format-sdcard-ok-btn');var dialogHeader=popup.querySelector('h1');var dialogContent=popup.querySelector('p');if(!this.external){dialogHeader.setAttribute('data-l10n-id','format-sdcard-internal-title');dialogContent.setAttribute('data-l10n-id','format-sdcard-internal-message');}else{dialogHeader.setAttribute('data-l10n-id','format-sdcard-title');dialogContent.setAttribute('data-l10n-id','format-sdcard-message');}
var self=this;var confirmHandler=function(){enablePopup(false);self.isFormatting=true;self.storages.sdcard.format();};var cancelHandler=function(){enablePopup(false);};var enablePopup=function Vf_enablePopup(enabled){if(enabled){okBtn.addEventListener('click',confirmHandler);cancelBtn.addEventListener('click',cancelHandler);popup.hidden=false;}else{okBtn.removeEventListener('click',confirmHandler);cancelBtn.removeEventListener('click',cancelHandler);popup.hidden=true;}};enablePopup(true);};Volume.prototype.enableUnmountSDCardBtn=function volume_enableUnmountSDCardBtn(enabled){if(this.external&&this.storages.sdcard.canBeMounted){var rule='button[class="eject-btn"]';this.rootElement.querySelector(rule).disabled=!enabled;if(enabled){this.setUnmountSDCardBtnVisible(enabled);}}};Volume.prototype.setUnmountSDCardBtnVisible=function volume_setUnmountSDCardBtnVisible(visible){if(this.external&&this.storages.sdcard.canBeMounted){var rule='li[class="eject-btn"]';this.rootElement.querySelector(rule).hidden=!visible;}};Volume.prototype.enableFormatSDCardBtn=function volume_enableFormatSDCardBtn(enabled,isFormatting){if(this.storages.sdcard.canBeFormatted){var formatBtn=this.rootElement.querySelector('.format-btn');formatBtn.disabled=!enabled;var l10nId='format-sdcard-'+this.getVolumeId();if(!enabled&&isFormatting){l10nId='formatting';}
formatBtn.setAttribute('data-l10n-id',l10nId);}};var MediaStorage={init:function ms_init(){this._volumeList=this.initAllVolumeObjects();this._handleExternalUnrecognisedChanged=this.handleExternalUnrecognisedChanged.bind(this);this._updateInfo=this.updateInfo.bind(this);this.documentStorageListener=false;this.usmEnabledVolume={};this.umsVolumeShareState=false;this.updateListeners(this._updateInfo);document.addEventListener('visibilitychange',this);this.defaultMediaLocationList=document.querySelector('.default-media-location');this.defaultMediaLocation=document.getElementById('defaultMediaLocation');this.defaultMediaLocation.addEventListener('click',this);this.makeDefaultLocationMenu();window.addEventListener('localized',this);},initAllVolumeObjects:function ms_initAllVolumeObjects(){var volumes={};var totalVolumes=0;MEDIA_TYPE.forEach(function(type){var storages=navigator.getDeviceStorages(type);storages.forEach(function(storage){var name=storage.storageName;if(!volumes.hasOwnProperty(name)){volumes[name]={};totalVolumes++;}
volumes[name][type]=storage;});});var volumeList=[];var externalIndex=0;var volumeListRootElement=document.getElementById('volume-list');for(var name in volumes){var volume;if(totalVolumes>1&&name==='sdcard'){volume=new Volume(name,false,0,volumes[name]);}else{volume=new Volume(name,true,externalIndex++,volumes[name]);}
volume.createView(volumeListRootElement);volumeList.push(volume);}
return volumeList;},handleEvent:function ms_handleEvent(evt){switch(evt.type){case'localized':this.updateInfo();break;case'change':if(evt.target.id==='ums-switch'){Storage.umsMasterSettingChanged(evt);}else if(evt.target.id==='defaultMediaLocation'){this.defaultLocationName=this.defaultMediaLocation.value;}else{this.updateInfo();}
break;case'storage-state-change':var storageStatus=evt.reason;var storageName=evt.currentTarget.storageName;this.updateStorageStatus(storageStatus,storageName);break;case'click':this.showChangingDefaultStorageConfirmation();break;case'visibilitychange':this.updateListeners(this._updateInfo,true);break;}},makeDefaultLocationMenu:function ms_makeDefaultLocationMenu(){var self=this;SettingsCache.getSettings(function(allSettings){self.defaultLocationName=allSettings[DEFAULT_MEDIA_VOLUME_KEY];var defaultName=allSettings[DEFAULT_MEDIA_VOLUME_KEY];var selectionMenu=self.defaultMediaLocation;var selectedIndex=0;self._volumeList.forEach(function(volume,index){var option=document.createElement('option');option.value=volume.name;var l10nId=volume.getL10nId(true);option.setAttribute('data-l10n-id',l10nId);selectionMenu.appendChild(option);if(defaultName&&volume.name===defaultName){selectedIndex=index;}});var selectedOption=selectionMenu.options[selectedIndex];selectedOption.selected=true;if(self._volumeList.length===1){self.enableDefaultMediaLocationSelection(false);var obj={};obj[DEFAULT_MEDIA_VOLUME_KEY]=selectedOption.value;navigator.mozSettings.createLock().set(obj);}else if(self._volumeList.length>1){self.updateDefaultMediaLocation();selectionMenu.addEventListener('change',self);}});},showChangingDefaultStorageConfirmation:function ms_showChangingDefaultStorageConfirmation(){var popup=document.getElementById('default-location-popup-container');var cancelBtn=document.getElementById('default-location-cancel-btn');var changeBtn=document.getElementById('default-location-change-btn');this.defaultMediaLocation.blur();var self=this;popup.hidden=false;cancelBtn.onclick=function(){popup.hidden=true;};changeBtn.onclick=function(){popup.hidden=true;setTimeout(function(){self.defaultMediaLocation.focus();});};},updateListeners:function ms_updateListeners(callback,isVisibilitychange){var self=this;if(document.hidden){if(this.documentStorageListener){this._volumeList.forEach(function(volume){var volumeStorage=volume.storages.sdcard;volumeStorage.removeEventListener('change',self);volumeStorage.removeEventListener('storage-state-change',self);});navigator.mozSettings.removeObserver(EXTERNAL_UNRECOGNISED_KEY,this._handleExternalUnrecognisedChanged);this.documentStorageListener=false;}}else{if(!this.documentStorageListener){this._volumeList.forEach(function(volume){var volumeStorage=volume.storages.sdcard;volumeStorage.addEventListener('change',self);volumeStorage.addEventListener('storage-state-change',self);});SettingsCache.getSettings(function(allSettings){var isUnrecognised=allSettings[EXTERNAL_UNRECOGNISED_KEY];this.enableFormatSDCardBtnForUnrecognisedStorage(isUnrecognised);if(callback){callback();}
if(isVisibilitychange&&(this._volumeList.length>1)){this.updateDefaultMediaLocation();}}.bind(this));navigator.mozSettings.addObserver(EXTERNAL_UNRECOGNISED_KEY,this._handleExternalUnrecognisedChanged);this.documentStorageListener=true;}}},enableFormatSDCardBtnForUnrecognisedStorage:function ms_enableFormatSDCardBtnForUnrecognisedStorage(enabled){if(this._volumeList.length===1){this._volumeList[0].isUnrecognised=enabled;this._volumeList[0].updateStorageUIState(enabled,true);this._volumeList[0].enableFormatSDCardBtn(enabled);}else if(this._volumeList.length>1){this._volumeList.forEach(function(volume){if(volume.external){volume.isUnrecognised=enabled;volume.updateStorageUIState(enabled,true);volume.enableFormatSDCardBtn(enabled);}}.bind(this));}},handleExternalUnrecognisedChanged:function ms_handleExternalUnrecognisedChanged(event){this.enableFormatSDCardBtnForUnrecognisedStorage(event.settingValue);},updateInfo:function ms_updateInfo(){var self=this;this.umsVolumeShareState=false;this._volumeList.forEach(function(volume){volume.updateInfo(function(state){if(state==='shared'){self.umsVolumeShareState=true;}});});},updateStorageStatus:function ms_updateStorageStatus(storageStatus,storageName){if(this._volumeList.length===1){this._volumeList[0].currentStorageStatus=storageStatus;this._volumeList[0].updateUIState(storageStatus);}else if(this._volumeList.length>1){this._volumeList.forEach(function(volume){if((storageName!=='sdcard')&&volume.external){volume.currentStorageStatus=storageStatus;volume.updateUIState(storageStatus);}else if((storageName==='sdcard')&&!volume.external){volume.currentStorageStatus=storageStatus;volume.updateUIState(storageStatus);}}.bind(this));if(storageStatus!=='Mounted'){this.enableDefaultMediaLocationSelection(false);if((storageName!=='sdcard')&&(this.defaultLocationName!=='sdcard')){if(storageStatus==='NoMedia'){this.setInternalStorageBeDefaultMediaLocation();}else if(storageStatus==='Idle'){setTimeout(function(){if(this._volumeList[1].currentStorageStatus==='Idle'){this.setInternalStorageBeDefaultMediaLocation();}}.bind(this),LATENCY_CHECK_STATUS_AFTER_IDLE_IN_MILLISECONDS);}}}else if(storageName!=='sdcard'){this.enableDefaultMediaLocationSelection(true);}}},updateDefaultMediaLocation:function ms_updateDefaultMediaLocation(){var externalVolume=this._volumeList[1];if(externalVolume.storages&&externalVolume.storages.sdcard){var self=this;var storageStatusReq=externalVolume.storages.sdcard.storageStatus();storageStatusReq.onsuccess=function storageStatusSuccess(evt){self._volumeList[1].currentStorageStatus=evt.target.result;var storageStatus=evt.target.result;if(storageStatus!=='Mounted'){self.enableDefaultMediaLocationSelection(false);if(self.defaultLocationName!=='sdcard'){if(storageStatus==='NoMedia'){self.setInternalStorageBeDefaultMediaLocation();}else if(storageStatus==='Idle'){setTimeout(function(){if(self._volumeList[1].currentStorageStatus==='Idle'){self.setInternalStorageBeDefaultMediaLocation();}},LATENCY_CHECK_STATUS_AFTER_IDLE_IN_MILLISECONDS);}}}else{self.enableDefaultMediaLocationSelection(true);}};}},setInternalStorageBeDefaultMediaLocation:function ms_setInternalStorageBeDefaultMediaLocation(){var selectedOption=this.defaultMediaLocation.options[0];selectedOption.selected=true;var obj={};obj[DEFAULT_MEDIA_VOLUME_KEY]=selectedOption.value;navigator.mozSettings.createLock().set(obj);},enableDefaultMediaLocationSelection:function ms_enableDefaultMediaLocationSelection(enabled){this.defaultMediaLocationList.setAttribute('aria-disabled',!enabled);this.defaultMediaLocation.disabled=!enabled;this.defaultMediaLocation.parentNode.setAttribute('aria-disabled',!enabled);}};var StackedBar=function(div){var container=div;var items=[];var totalSize=0;return{add:function sb_add(item){totalSize+=item.value;items.push(item);},refreshUI:function sb_refreshUI(){container.parentNode.setAttribute('aria-disabled',false);container.parentNode.hidden=false;items.forEach(function(item){var className='color-'+item.type;var ele=container.querySelector('.'+className);if(!ele){ele=document.createElement('span');ele.classList.add(className);ele.classList.add('stackedbar-item');container.appendChild(ele);}
ele.style.width=(item.value*100)/totalSize+'%';});},reset:function sb_reset(){items=[];totalSize=0;container.parentNode.setAttribute('aria-disabled',true);container.parentNode.hidden=true;}};};MediaStorage.init();});