
define(['require','modules/defer','modules/base/module','modules/mvvm/observable'],function(require){'use strict';var Defer=require('modules/defer');var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');var TaskScheduler=Module.create(function TaskScheduler(){this.super(Observable).call(this);this.isLocked=false;this._tasks=[];}).extend(Observable);Observable.defineObservableProperty(TaskScheduler.prototype,'isLocked',{value:false});const TASK_TYPE={GENERAL:0};Object.defineProperty(TaskScheduler,'TASK_TYPE',{enumerable:true,configurable:false,get:function(){return TASK_TYPE;}});TaskScheduler.prototype._lock=function(){this.isLocked=true;};TaskScheduler.prototype._unlock=function(){this.isLocked=false;this._executeNextTask();};TaskScheduler.prototype._removeRedundantTasks=function(type){return this._tasks.filter((task)=>{if(!task.cancelable){return true;}else{return task.type!==type;}});};TaskScheduler.prototype._executeNextTask=function(){if(this.isLocked){return;}
var nextTask=this._tasks.shift();if(nextTask){this._lock();return nextTask.func().then((result)=>{nextTask.defer.resolve(result);this._unlock();},()=>{nextTask.defer.reject();this._unlock();});}};TaskScheduler.prototype.enqueue=function(task){var defer=Defer();if(!task.func){return Promise.resolve();}
if(!task.type){task=Object.assign({},task);task.type=TaskScheduler.TASK_TYPE.GENERAL;}
task.defer=defer;this._tasks=this._removeRedundantTasks(task.type);this._tasks.push(task);this._executeNextTask();return defer.promise;};return TaskScheduler;});