
define(['require','modules/bluetooth/bluetooth_adapter_manager','shared/async_storage'],function(require){'use strict';var AdapterManager=require('modules/bluetooth/bluetooth_adapter_manager');var AsyncStorage=require('shared/async_storage');var _debug=false;var debug=function(){};if(_debug){debug=function btam_debug(msg){console.log('--> [BluetoothConnectionManager]: '+msg);};}
var BluetoothConnectionManager={Profiles:{'hfp':0x111E,'a2dp':0x110D},connectingAddress:null,_connectedDevicesInfo:{},_getConnectedDevicesPromise:null,_listeners:{'connecting':[],'connected':[],'disconnected':[],'profileChanged':[]},_defaultAdapter:null,_init:function btcm__init(){AdapterManager.observe('defaultAdapter',this._onDefaultAdapterChanged.bind(this));this._onDefaultAdapterChanged(AdapterManager.defaultAdapter);},_onDefaultAdapterChanged:function btcm__onDefaultAdapterChanged(newAdapter,oldAdapter){debug('_onDefaultAdapterChanged(): newAdapter = '+newAdapter);debug('_onDefaultAdapterChanged(): oldAdapter = '+oldAdapter);this._defaultAdapter=newAdapter;if(oldAdapter){this._unwatchProfilesStatuschanged(oldAdapter);this._unwatchDefaultAdapterOnattributechanged(oldAdapter);}
if(newAdapter){this._watchProfilesStatuschanged(newAdapter);this._watchDefaultAdapterOnattributechanged(newAdapter);if(newAdapter.state==='enabled'){this._restoreConnection();}}else{this._resetConnectionInfo();}},getConnectedDevices:function btcm_getConnectedDevices(){if(!this._getConnectedDevicesPromise){this._getConnectedDevicesPromise=this._initConnectedDevicesInfo().then(()=>{debug('getConnectedDevices(): resolved with latest cache = '+
JSON.stringify(this._connectedDevicesInfo));return this._connectedDevicesInfo;},(reason)=>{debug('getConnectedDevices(): rejected with reason = '+reason);this._getConnectedDevicesPromise=null;});}
return this._getConnectedDevicesPromise;},_initConnectedDevicesInfo:function btcm__initConnectedDevicesInfo(){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._getConnectedDevicesFromPlatform().then((connectedDevicesByProfile)=>{this._constructDeviceItemsMap(connectedDevicesByProfile);},(reason)=>{debug('_initConnectedDevicesInfo(): rejected in '+'_getConnectedDevicesFromPlatform');return Promise.reject(reason);});},_constructDeviceItemsMap:function btcm__constructDeviceItemsMap(connectedDevices){debug('_constructDeviceItemsMap(): connectedDevices = '+
JSON.stringify(connectedDevices));if(!connectedDevices){debug('_constructDeviceItemsMap(): early return with empty object');return;}
Object.keys(this.Profiles).map((profileID)=>{connectedDevices[profileID].forEach((connectedDevice)=>{var connectionDeviceInfo={address:connectedDevice.address,connected:true,profileID:profileID,device:connectedDevice};debug('_constructDeviceItemsMap(): connectionDeviceInfo = '+
JSON.stringify(connectionDeviceInfo));this._initConnectedDevicesCache(connectionDeviceInfo);});});},_initConnectedDevicesCache:function btcm__initConnectedDevicesCache(options){debug('_initConnectedDevicesCache(): options = '+
JSON.stringify(options));var info=this._connectedDevicesInfo[options.address];if(info){info.connectedProfiles[options.profileID]=options.connected;}else{var connectedDevice=(options.device)?options.device:null;info={'device':connectedDevice,'connectedProfiles':{}};info.connectedProfiles[options.profileID]=options.connected;}
this._connectedDevicesInfo[options.address]=info;var dataToCheckConnectedProfile={address:options.address,connectedDevices:this._connectedDevicesInfo};if(!this._hasConnectedProfileByAddress(dataToCheckConnectedProfile)){delete this._connectedDevicesInfo[options.address];}
debug('_initConnectedDevicesCache(): this._connectedDevicesInfo = '+
JSON.stringify(this._connectedDevicesInfo));return this._connectedDevicesInfo;},_updateConnectedDevices:function btcm__updateConnectedDevices(options){return this.getConnectedDevices().then((connectedDevicesInfo)=>{debug('_updateConnectedDevices(): connectedDevicesInfo = '+
JSON.stringify(connectedDevicesInfo));var info=(connectedDevicesInfo)?connectedDevicesInfo[options.address]:null;if(info){info.connectedProfiles[options.profileID]=options.connected;}else{var connectedDevice=(options.device)?options.device:null;info={'device':connectedDevice,'connectedProfiles':{}};info.connectedProfiles[options.profileID]=options.connected;}
this._connectedDevicesInfo[options.address]=info;var dataToCheckConnectedProfile={address:options.address,connectedDevices:this._connectedDevicesInfo};if(!this._hasConnectedProfileByAddress(dataToCheckConnectedProfile)){delete this._connectedDevicesInfo[options.address];}
debug('_updateConnectedDevices(): this._connectedDevicesInfo = '+
JSON.stringify(this._connectedDevicesInfo));return Promise.resolve(this._connectedDevicesInfo);},()=>{debug('_updateConnectedDevices(): rejected with some exception');return Promise.reject('rejected with some exception');});},_resetConnectionInfo:function btcm__resetConnectionInfo(){this.connectingAddress=null;this._getConnectedDevicesPromise=null;},_watchDefaultAdapterOnattributechanged:function btcm__watchDefaultAdapterOnattributechanged(adapter){adapter.addEventListener('attributechanged',this._onAdapterAttributeChanged.bind(this,adapter));},_unwatchDefaultAdapterOnattributechanged:function btcm__unwatchDefaultAdapterOnattributechanged(adapter){adapter.removeEventListener('attributechanged',this._onAdapterAttributeChanged);},_onAdapterAttributeChanged:function btcm__onAdapterAttributeChanged(adapter,evt){for(var i in evt.attrs){debug('_onAdapterAttributeChanged(): '+evt.attrs[i]);switch(evt.attrs[i]){case'state':if(adapter.state==='enabled'){this._restoreConnection();}
break;default:break;}}},_watchProfilesStatuschanged:function btcm__watchProfilesStatuschanged(adapter){var eventName;for(var profileID in this.Profiles){eventName='on'+profileID+'statuschanged';adapter[eventName]=this._onProfileStatuschangeHandler.bind(this,profileID);}},_unwatchProfilesStatuschanged:function btc__unwatchProfilesStatuschanged(adapter){var eventName;for(var profileID in this.Profiles){eventName='on'+profileID+'statuschanged';adapter[eventName]=null;}},_onProfileStatuschangeHandler:function btcm__onProfileStatuschangeHandler(profileID,evt){debug('_onProfileStatuschangeHandler(): profileID = '+profileID+', evt.address = '+evt.address+', evt.status = '+evt.status);var options={address:evt.address,connected:evt.status,profileID:profileID};this._updateConnectionStatus(options);},_restoreConnection:function btcm__restoreConnection(){if(!this._defaultAdapter){return;}
AsyncStorage.getItem('device.connected',(address)=>{if(!address){return;}
this.getConnectedDevices().then((connectedDevices)=>{if(connectedDevices&&connectedDevices[address]){debug('_restoreConnection(): early return cause connected already');return;}
var restoreDevice=this._getPairedDeviceByAddress(address);if(restoreDevice){this.connectingAddress=restoreDevice.address;var event={type:'connecting',detail:{address:restoreDevice.address}};this._emitEvent(event);this._connect(restoreDevice).then(()=>{debug('_restoreConnection(): restore connection successfully');},(reason)=>{debug('_restoreConnection(): restore connection failed, '+'reason = '+reason);this.connectingAddress=null;event={type:'disconnected',detail:{address:restoreDevice.address}};this._emitEvent(event);});}});});},_recordConnection:function btcm__recordConnection(action,address){if(action==='set'){AsyncStorage.setItem('device.connected',address);debug('_recordConnection(): set item');}else if((action==='remove')&&(this._defaultAdapter.state==='enabled')){AsyncStorage.removeItem('device.connected');debug('_recordConnection(): remove item');}},_updateConnectionStatus:function btcm___updateConnectionStatus(options){debug('_updateConnectionStatus(): address = '+options.address+', connected = '+options.connected+', profileID = '+options.profileID);this.connectingAddress=null;this._updateConnectedDevices(options).then((connectedDevicesInfo)=>{debug('_updateConnectionStatus(): _updateConnectedDevices() '+'resolved with connectedDevicesInfo = '+
JSON.stringify(connectedDevicesInfo));var dataToCheckConnectedProfile={address:options.address,connectedDevices:connectedDevicesInfo};var event;if(options.connected){event={type:'connected',detail:{address:options.address}};this._emitEvent(event);this._recordConnection('set',options.address);}else{if(!this._hasConnectedProfileByAddress(dataToCheckConnectedProfile)){if(this._defaultAdapter.state==='enabled'){this._recordConnection('remove');}
event={type:'disconnected',detail:{address:options.address}};this._emitEvent(event);}}
var newProfiles;if(!this._hasConnectedProfileByAddress(dataToCheckConnectedProfile)){newProfiles=null;}else{newProfiles=connectedDevicesInfo[options.address].connectedProfiles;}
event={type:'profileChanged',detail:{address:options.address,profiles:newProfiles}};this._emitEvent(event);},(reason)=>{debug('_updateConnectionStatus(): miss to update in rejected case, '+'reason = '+reason);});},connect:function btcm_connect(device){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
debug('connect(): Want to connect device address = '+device.address+', name = '+device.name);var connectedDevices=[];return this.getConnectedDevices().then((connectedDevicesInfo)=>{for(var address in connectedDevicesInfo){if(connectedDevicesInfo[address].device!==null){connectedDevices.push(connectedDevicesInfo[address].device);debug('connect(): push device cache in queue = '+
JSON.stringify(connectedDevices));}else{var regetPairedDevice=this._getPairedDeviceByAddress(address);connectedDevices.push(regetPairedDevice);debug('connect(): push _getPairedDeviceByAddress in queue = '+
JSON.stringify(regetPairedDevice));}}
debug('connect(): Will disconnect these connected devices = '+
JSON.stringify(connectedDevices));return Promise.all(connectedDevices.map((connectedDevice)=>{return this.disconnect(connectedDevice);})).then(()=>{debug('connect(): Start to connect with wanted device address = '+
device.address);return this._connect(device).then(()=>{debug('connect(): Resolved');},(reason)=>{debug('connect(): reason = '+reason);return Promise.reject(reason);});});});},_connect:function btcm__connect(device){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
this.connectingAddress=device.address;var event={type:'connecting',detail:{address:device.address}};this._emitEvent(event);debug('_connect(): before start to connect, stop discovery first');return this._defaultAdapter.stopDiscovery().then(()=>{debug('_connect(): start connecting device, '+'address = '+device.address);return this._defaultAdapter.connect(device).then(()=>{debug('_connect(): resolve, already connected with address = '+
device.address);},()=>{this.connectingAddress=null;event={type:'disconnected',detail:{address:device.address}};this._emitEvent(event);debug('_connect(): reject with connection failed');return Promise.reject('connection failed');});},()=>{this.connectingAddress=null;event={type:'disconnected',detail:{address:device.address}};this._emitEvent(event);debug('_connect(): reject with stop discovery failed');return Promise.reject('stop discovery failed');});},disconnect:function btcm_disconnect(device){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.disconnect(device).then(()=>{debug('disconnect(): onsuccess(): resolve');},()=>{debug('disconnect(): onerror(): reject with disconnect failed');return Promise.reject('disconnect failed');});},_getConnectedDevicesFromPlatform:function btcm__getConnectedDevicesFromPlatform(){return Promise.all(Object.keys(this.Profiles).map((profile)=>{return this._getConnectedDevicesByProfile(this.Profiles[profile]);})).then((connectedDevices)=>{var collectedConnectedDevicesByProfile={};Object.keys(this.Profiles).forEach((profile,index)=>{collectedConnectedDevicesByProfile[profile]=connectedDevices[index];});debug('_getConnectedDevicesFromPlatform(): '+'collectedConnectedDevicesByProfile = '+
JSON.stringify(collectedConnectedDevicesByProfile));return Promise.resolve(collectedConnectedDevicesByProfile);});},_getConnectedDevicesByProfile:function btcm__getConnectedDevicesByProfile(profileID){if(!this._defaultAdapter){debug('_getConnectedDevicesByProfile(): reject with no adapter');return Promise.reject('default adapter is not existed!!');}
if(this._defaultAdapter.state==='disabled'){debug('_getConnectedDevicesByProfile(): resolve with empty array '+'since it is impossible to connect with any device');return Promise.reject('getConnectedDevices in disabled state');}
return this._defaultAdapter.getConnectedDevices(profileID).then((connectedDevice)=>{debug('_getConnectedDevicesByProfile(): resolved with '+'connectedDevice = '+JSON.stringify(connectedDevice));return Promise.resolve(connectedDevice||[]);},(reason)=>{debug('_getConnectedDevicesByProfile(): rejected with '+'reason = '+reason);return Promise.reject(reason);});},_getPairedDeviceByAddress:function btcm__getPairedDeviceByAddress(address){if(!this._defaultAdapter){return null;}
var pairedDevices=this._defaultAdapter.getPairedDevices();if(pairedDevices.length===0){return null;}else{for(var i in pairedDevices){if(pairedDevices[i].address===address){return pairedDevices[i];}}
return null;}},_hasConnectedProfileByAddress:function btcm__hasConnectedProfileByAddress(options){if(!options.connectedDevices[options.address]){return false;}
var hasConnectedProfile=false;for(var profileID in this.Profiles){var connectedProfiles=options.connectedDevices[options.address].connectedProfiles;if(connectedProfiles&&(connectedProfiles[profileID]===true)){hasConnectedProfile=true;}}
return hasConnectedProfile;},_emitEvent:function btcm__emitEvent(options){this._listeners[options.type].forEach(function(listener){listener(options);});},addEventListener:function btcm_addEventListener(eventName,callback){if(callback&&(this._listeners.hasOwnProperty(eventName))){this._listeners[eventName].push(callback);}},removeEventListener:function btcm_removeEventListener(eventName,callback){if(callback&&(this._listeners.hasOwnProperty(eventName))){var index=this._listeners[eventName].indexOf(callback);if(index>=0){this._listeners[eventName].splice(index,1);}}}};BluetoothConnectionManager._init();return BluetoothConnectionManager;});