
define(['require','modules/bluetooth/bluetooth_adapter_manager','modules/bluetooth/bluetooth_device','modules/bluetooth/bluetooth_connection_manager','modules/mvvm/observable','modules/mvvm/observable_array','modules/settings_cache'],function(require){'use strict';var AdapterManager=require('modules/bluetooth/bluetooth_adapter_manager');var BtDevice=require('modules/bluetooth/bluetooth_device');var ConnectionManager=require('modules/bluetooth/bluetooth_connection_manager');var Observable=require('modules/mvvm/observable');var ObservableArray=require('modules/mvvm/observable_array');var SettingsCache=require('modules/settings_cache');var settings=navigator.mozSettings;var _debug=false;var debug=function(){};if(_debug){debug=function btc_debug(msg){console.log('--> [BluetoothContext]: '+msg);};}
var BluetoothContext={state:'disabled',enabled:undefined,address:null,name:'',discoverable:false,discovering:false,numberOfPairedDevices:0,firstPairedDeviceName:'',hasPairedDevice:false,_defaultAdapter:null,_init:function btc__init(){AdapterManager.observe('defaultAdapter',this._onDefaultAdapterChanged.bind(this));this._onDefaultAdapterChanged(AdapterManager.defaultAdapter);ConnectionManager.addEventListener('connecting',this._updateDeviceConnectionInfo.bind(this));ConnectionManager.addEventListener('connected',this._updateDeviceConnectionInfo.bind(this));ConnectionManager.addEventListener('disconnected',this._updateDeviceConnectionInfo.bind(this));ConnectionManager.addEventListener('profileChanged',this._updateDeviceConnectionInfo.bind(this));},_initProperties:function btc__initProperties(adapter){this._updateStatus(adapter.state);this.address=adapter.address;this.name=adapter.name;this.discoverable=adapter.discoverable;this.discovering=adapter.discovering;},_resetProperties:function btc__resetProperties(){this._updateStatus('disabled');this.address='';this.name='';this.discoverable=false;this.discovering=false;},_watchDefaultAdapterAttributechanged:function btc__watchDefaultAdapterAttributechanged(adapter){adapter.addEventListener('attributechanged',this._onAdapterAttributeChanged.bind(this,adapter));},_unwatchDefaultAdapterAttributechanged:function btc__unwatchDefaultAdapterAttributechanged(adapter){adapter.removeEventListener('attributechanged',this._onAdapterAttributeChanged);},_watchDefaultAdapterOndevicepaired:function btc__watchDefaultAdapterOndevicepaired(adapter){adapter.ondevicepaired=this._onAdapterDevicepaired.bind(this,adapter);},_unwatchDefaultAdapterOndevicepaired:function btc__unwatchDefaultAdapterOndevicepaired(adapter){adapter.ondevicepaired=null;},_watchDefaultAdapterOndeviceunpaired:function btc__watchDefaultAdapterOndeviceunpaired(adapter){adapter.ondeviceunpaired=this._onAdapterDeviceunpaired.bind(this,adapter);},_unwatchDefaultAdapterOndeviceunpaired:function btc__unwatchDefaultAdapterOndeviceunpaired(adapter){adapter.ondeviceunpaired=null;},_onAdapterAttributeChanged:function btc__onAdapterAttributeChanged(adapter,evt){for(var i in evt.attrs){debug('--> _onAdapterAttributeChanged(): '+evt.attrs[i]);switch(evt.attrs[i]){case'state':this._updateStatus(adapter.state);if(adapter.state==='enabled'){this._refreshPairedDevicesInfo(adapter);this.startDiscovery();}
break;case'address':this.address=adapter.address;break;case'name':this.name=adapter.name;break;case'discoverable':this.discoverable=adapter.discoverable;break;case'discovering':this.discovering=adapter.discovering;break;default:break;}}},_onAdapterDevicepaired:function btc__onAdapterDevicepaired(adapter,evt){debug('_onAdapterDevicepaired evt = '+evt);this._removeItemFromList(this._remoteDevices,evt.device.address);this._refreshPairedDevicesInfo(adapter);},_onAdapterDeviceunpaired:function btc__onAdapterDeviceunpaired(adapter,evt){debug('_onAdapterDeviceunpaired evt = '+evt);this._refreshPairedDevicesInfo(adapter);},_onDefaultAdapterChanged:function btc__onDefaultAdapterChanged(newAdapter,oldAdapter){debug('_onDefaultAdapterChanged(): newAdapter = '+newAdapter);debug('_onDefaultAdapterChanged(): oldAdapter = '+oldAdapter);this._defaultAdapter=newAdapter;if(oldAdapter){this._unwatchDefaultAdapterAttributechanged(oldAdapter);this._unwatchDefaultAdapterOndeviceunpaired(oldAdapter);this._unwatchDefaultAdapterOndevicepaired(oldAdapter);}
if(newAdapter){this._initProperties(newAdapter);this._watchDefaultAdapterAttributechanged(newAdapter);this._watchDefaultAdapterOndevicepaired(newAdapter);this._watchDefaultAdapterOndeviceunpaired(newAdapter);if(newAdapter.state==='enabled'){this._refreshPairedDevicesInfo(newAdapter);}}else{this._resetProperties();}},_refreshPairedDevicesInfo:function btc__refreshPairedDevicesInfo(adapter){var pairedDevices=adapter.getPairedDevices();debug('pairedDevices.length = '+pairedDevices.length);this._pairedDevices.reset([]);if(pairedDevices.length===0){this.firstPairedDeviceName='';this.hasPairedDevice=false;}else{pairedDevices.sort(function(a,b){return a.name>b.name;});for(var i in pairedDevices){var observableBtDevice=BtDevice(pairedDevices[i]);this._pairedDevices.push(observableBtDevice);}
this.firstPairedDeviceName=this._pairedDevices.get(0).name;this.hasPairedDevice=true;this._initConnectingDevices();this._initConnectedDevices();}
this.numberOfPairedDevices=pairedDevices.length;},_updateStatus:function btc__updateStatus(state){var enabled;if(state==='enabled'||state==='disabling'){enabled=true;}else if(state==='disabled'||state==='enabling'){enabled=false;}
this.state=state;debug('_updateStatus(): set state = '+state);this.enabled=enabled;debug('_updateStatus(): set enabled = '+enabled);this._syncWithSettingsKey(enabled);},_syncWithSettingsKey:function btc__syncWithSettingsKey(enabled){SettingsCache.getSettings((results)=>{var btEnabled=results['bluetooth.enabled'];if(btEnabled!==enabled){settings.createLock().set({'bluetooth.enabled':enabled});}});},setEnabled:function btc_setEnabled(enabled){debug('setEnabled(): request set enabled = '+enabled);if((this.enabled===enabled)||(this.state==='enabling')||(this.state==='disabling')){return Promise.reject('state transition!!');}
if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
if(enabled){return this._defaultAdapter.enable().then(()=>{debug('setEnabled(): set enable successfully :)');},(reason)=>{debug('setEnabled(): set enable failed: reason = '+reason);return Promise.reject(reason);});}else{return this._defaultAdapter.disable().then(()=>{debug('setEnabled(): set disable successfully :)');},(reason)=>{debug('setEnabled(): set disable failed: reason = '+reason);return Promise.reject(reason);});}},setDiscoverable:function btc_setDiscoverable(enabled){if((this.discoverable===enabled)||(this.state!=='enabled')){return Promise.reject('same state or Bluetooth is disabled!!');}
if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.setDiscoverable(enabled).then(()=>{debug('setDiscoverable(): set discoverable '+
enabled+' successfully :)');},(reason)=>{debug('setDiscoverable(): set discoverable failed: '+'reason = '+reason);return Promise.reject(reason);});},setName:function btc_setName(name){if(name===this.name){return Promise.reject('same name!!');}
if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.setName(name).then(()=>{debug('setName(): set name successfully :) name = '+
this._defaultAdapter.name);},(reason)=>{debug('setName(): set name failed: reason = '+reason);return Promise.reject(reason);});},setNameByProductModel:function btc_setNameByProductModel(){SettingsCache.getSettings((results)=>{var productModel=results['deviceinfo.product_model'];debug('setNameByProductModel(): productModel = '+productModel);this.setName(productModel);});},_pairedDevices:ObservableArray([]),_remoteDevices:ObservableArray([]),_discoveryHandler:null,startDiscovery:function btc_startDiscovery(){if((this.discovering===true)||(this.state!=='enabled')){return Promise.reject('same state or Bluetooth is disabled!!');}
this._remoteDevices.reset([]);if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.startDiscovery().then((handle)=>{debug('startDiscovery(): startDiscovery successfully :)');this._setDiscoveryHandler(handle);},(reason)=>{debug('startDiscovery(): startDiscovery failed: '+'reason = '+reason);return Promise.reject(reason);});},stopDiscovery:function btc_stopDiscovery(){if(this.discovering===false){debug('stopDiscovery(): stopDiscovery successfully in same state :)');return Promise.resolve('same state');}
if(this.state!=='enabled'){return Promise.reject('Bluetooth is disabled!!');}
if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.stopDiscovery().then(()=>{debug('stopDiscovery(): stopDiscovery successfully :)');},(reason)=>{debug('stopDiscovery(): stopDiscovery failed: reason = '+reason);return Promise.reject(reason);});},_setDiscoveryHandler:function btc__setDiscoveryHandler(handle){debug('_setDiscoveryHandler(): handle = '+handle);this._discoveryHandler=handle;this._discoveryHandler.ondevicefound=this._onDeviceFound.bind(this);},_onDeviceFound:function btc__onDeviceFound(evt){this._saveDevice(evt.device);},_saveDevice:function btc__saveDevice(device){var existedDevice=this._findDeviceByAddress({paired:device.paired,address:device.address});if(!existedDevice){var observableBtDevice=BtDevice(device);var operatingDevices=(device.paired)?this.getPairedDevices():this.getRemoteDevices();operatingDevices.push(observableBtDevice);}else{}},_removeItemFromList:function btc__removeItemFromList(list,address){var index=list.array.findIndex(this._matchDeviceByAddress.bind(this,address));if(index>-1){list.splice(index,1);debug('_removeItemFromList(): index = '+index);}else{}},_findDeviceByAddress:function btc__findDeviceByAddress(options){var operatingDevices=(options.paired)?this.getPairedDevices():this.getRemoteDevices();var index=operatingDevices.array.findIndex(this._matchDeviceByAddress.bind(this,options.address));if(index>-1){return operatingDevices.get(index);}else{return null;}},_matchDeviceByAddress:function btc__matchDeviceByAddress(address,btDevice){return btDevice.address&&(btDevice.address===address);},getPairedDevices:function btc_getPairedDevices(){return this._pairedDevices;},getRemoteDevices:function btc_getRemoteDevices(){return this._remoteDevices;},pair:function btc_pair(address){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this.stopDiscovery().then(()=>{return this._defaultAdapter.pair(address).then(()=>{debug('pair(): Resolved with void value');},(reason)=>{debug('pair(): Reject with this reason: '+reason);return Promise.reject(reason);});},(reason)=>{return Promise.reject(reason);});},unpair:function btc_unpair(address){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.unpair(address).then(()=>{debug('unpair(): Resolved with void value');},(reason)=>{debug('unpair(): Reject with this reason: '+reason);return Promise.reject(reason);});},sendFile:function btc_sendFile(address,blob){if(!this._defaultAdapter){return Promise.reject('default adapter is not existed!!');}
return this._defaultAdapter.sendFile(address,blob).then(()=>{debug('sendFile(): Resolved with void value');},(reason)=>{debug('sendFile(): Reject with this reason: '+reason);return Promise.reject(reason);});},_initConnectingDevices:function btc__initConnectingDevices(){if(!ConnectionManager.connectingAddress){return;}
var existedDevice=this._findDeviceByAddress({paired:true,address:ConnectionManager.connectingAddress});if(existedDevice){var options={connectionStatus:'connecting'};debug('_initConnectingDevices(): options = '+JSON.stringify(options));existedDevice.updateConnectionInfo(options);}},_initConnectedDevices:function btc__initConnectedDevices(){ConnectionManager.getConnectedDevices().then((connectedDevices)=>{for(var address in connectedDevices){var existedDevice=this._findDeviceByAddress({paired:true,address:address});if(existedDevice){var options={connectionStatus:'connected',profiles:connectedDevices[address].connectedProfiles};debug('_initConnectedDevices(): address = '+address+', options = '+JSON.stringify(options));existedDevice.updateConnectionInfo(options);}}},(reason)=>{debug('_initConnectedDevices(): getConnectedDevices(): failed, '+'reason = '+reason);});},_updateDeviceConnectionInfo:function btc__updateDeviceConnectionInfo(event){debug('_updateDeviceConnectionInfo(): event = '+JSON.stringify(event));var existedDevice=this._findDeviceByAddress({paired:true,address:event.detail.address});if(existedDevice){var options;switch(event.type){case'connecting':case'connected':case'disconnected':options={connectionStatus:event.type};break;case'profileChanged':options={profiles:event.detail.profiles};break;default:break;}
debug('_updateDeviceConnectionInfo(): options = '+
JSON.stringify(options));existedDevice.updateConnectionInfo(options);}else{}}};var bluetoothContext=Observable(BluetoothContext);bluetoothContext._init();return bluetoothContext;});