
define(['require','shared/manifest_helper','modules/addon_manager'],function(require){'use strict';var ManifestHelper=require('shared/manifest_helper');var AddonManager=require('modules/addon_manager');const PREFERRED_ICON_SIZE=64*(window.devicePixelRatio||1);function AddonDetails(elements){this._boundUpdateEnabledState=this._updateEnabledState.bind(this);this._elements=elements;this._curApp=null;}
AddonDetails.prototype._updateEnabledState=function _update(newState){this._elements.enabledState.setAttribute('data-l10n-id',newState?'enabled':'disabled');};AddonDetails.prototype.render=function render(app){if(this._curApp!==null){this._curApp.unobserve('enabled',this._boundUpdateEnabledState);}
this._curApp=app;if(this._curApp){this._curApp.observe('enabled',this._boundUpdateEnabledState);this._updateEnabledState(this._curApp.enabled);}
var l10n=navigator.mozL10n;var manifest=new ManifestHelper(app.instance.manifest||app.instance.updateManifest);this.updateNames(manifest);navigator.mozApps.mgmt.getIcon(app,PREFERRED_ICON_SIZE).then((blob)=>{this._elements.icon.src=URL.createObjectURL(blob);}).catch(()=>{this._elements.icon.src='../style/images/default.png';});if(manifest.version){this._elements.version.textContent='v'+manifest.version;}
if(manifest.description){this._elements.description.removeAttribute('data-l10n-id');this._elements.description.textContent=manifest.description;}else{this._elements.description.setAttribute('data-l10n-id','addon-no-description');}
var developerName=manifest.developer&&manifest.developer.name;l10n.setAttributes(this._elements.developer,'addon-developer-name',{developerName:developerName||''});var oldAddonFormat=!!manifest.customizations;if(oldAddonFormat){l10n.setAttributes(this._elements.obsoleteStatusInfo,AddonManager.canDelete(app)?'addon-obsolete-can-delete':'addon-obsolete');}
this._elements.obsoleteStatus.hidden=!oldAddonFormat;this._elements.targetsList.textContent='';AddonManager.getAddonTargets(app).then((targets)=>{var names=[];targets.forEach(function(target){var manifest=new ManifestHelper(target.manifest||target.updateManifest);names.push(manifest.displayName);});names.sort();if(names.length<1){this._elements.targetsList.setAttribute('data-l10n-id','addon-no-targets');}else{this._elements.targetsList.textContent=names.join(', ');}});};AddonDetails.prototype.updateNames=function _updateNames(manifest){var appnameArgs={appName:manifest.name};var l10n=navigator.mozL10n;l10n.setAttributes(this._elements.header,'addon-details-header1',appnameArgs);l10n.setAttributes(this._elements.name,'addon-details-header1',appnameArgs);l10n.setAttributes(this._elements.icon,'accessibility-app-icon',appnameArgs);};return function ctor_addon_details(panel){return new AddonDetails(panel);};});