
define('panels/operator_settings/models/panel_model',['require','modules/base/module','modules/mvvm/observable'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');const NETWORK_TYPE_CATEGORY={'gprs':'gsm','edge':'gsm','umts':'gsm','hsdpa':'gsm','hsupa':'gsm','hspa':'gsm','hspa+':'gsm','lte':'gsm','gsm':'gsm','is95a':'cdma','is95b':'cdma','1xrtt':'cdma','evdo0':'cdma','evdoa':'cdma','evdob':'cdma','ehrpd':'cdma'};var PanelModel=Module.create(function OperatorSettingsPanelModel(conn){this.super(Observable).call(this);this._voiceType=conn.voice&&conn.voice.type;getSupportedNetworkInfo(conn,(result)=>{if(result.gsm||result.wcdma||result.lte){this._hardwareSupportedMode='gsm';}else{this._hardwareSupportedMode='cdma';}});conn.addEventListener('voicechange',()=>{this._voiceType=conn.voice&&conn.voice.type;});}).extend(Observable);Observable.defineObservableProperty(PanelModel.prototype,'_hardwareSupportedMode',{value:null});Observable.defineObservableProperty(PanelModel.prototype,'_voiceType',{value:null});Observable.defineObservableProperty(PanelModel.prototype,'connectingMode',{dependency:['_voiceType','_hardwareSupportedMode'],get:function(){if(this._voiceType){return NETWORK_TYPE_CATEGORY[this._voiceType];}else{return this._hardwareSupportedMode;}}});return PanelModel;});define('panels/operator_settings/models/network_type_manager',['require','modules/base/module','modules/mvvm/observable','modules/mvvm/observable_array','shared/settings_helper'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');var ObservableArray=require('modules/mvvm/observable_array');var SettingsHelper=require('shared/settings_helper');const SETTINGS_KEY='ril.radio.preferredNetworkType';var NetworkTypeManager=Module.create(function NetworkTypeManager(conn){if(!conn.setPreferredNetworkType){this.throw(`mobile connection does not support settings preferred network
        type`);}
this.super(Observable).call(this);this._conn=conn;this._serviceId=[].indexOf.call(navigator.mozMobileConnections,conn);this._networkTypes=ObservableArray([]);this._supportedNetworkInfo=null;this._settingsHelper=SettingsHelper(SETTINGS_KEY);this._init(conn);}).extend(Observable);Object.defineProperty(NetworkTypeManager.prototype,'networkTypes',{enumerable:true,get:function(){return this._networkTypes;}});Observable.defineObservableProperty(NetworkTypeManager.prototype,'preferredNetworkType',{readonly:true,value:null});NetworkTypeManager.prototype._init=function(){this.getSupportedNetworkInfo().then((info)=>{if(!info.networkTypes){return Promise.reject('not-supported');}
this._networkTypes.reset(info.networkTypes);return this._conn.getPreferredNetworkType();}).then((preferredNetworkType)=>{this._preferredNetworkType=preferredNetworkType;}).catch((error)=>{if(error==='not-supported'){this.debug('_init: not-supported');}else{this.error('_init: could not retrieve network type: '+error);}});};NetworkTypeManager.prototype.getSupportedNetworkInfo=function(){if(this._supportedNetworkInfo){return Promise.resolve(this._supportedNetworkInfo);}else{return new Promise((resolve)=>{getSupportedNetworkInfo(this._conn,(info)=>{this._supportedNetworkInfo=info;resolve(info);});});}};NetworkTypeManager.prototype.setPreferredNetworkType=function(networkType){return this._conn.setPreferredNetworkType(networkType).then(()=>{this._settingsHelper.get((values)=>{values[this._serviceId]=networkType;this._settingsHelper.set(values);});this._preferredNetworkType=networkType;},(error)=>{this.error('setPreferredNetworkType: '+error);});};return NetworkTypeManager;});define('panels/operator_settings/models/roaming_preference_manager',['require','modules/base/module','modules/mvvm/observable','shared/settings_helper'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');var SettingsHelper=require('shared/settings_helper');const SETTINGS_KEY='ril.roaming.preference';var RoamingPreferenceManager=Module.create(function RoamingPreferenceManager(conn){if(!conn.setRoamingPreference){this.throw(`mobile connection does not support setting roaming
          preference`);}
this.super(Observable).call(this);this._conn=conn;this._serviceId=[].indexOf.call(navigator.mozMobileConnections,conn);var defaultRoamingPreferences=[].map.call(navigator.mozMobileConnections,()=>{return'any';});this._settingsHelper=SettingsHelper(SETTINGS_KEY,defaultRoamingPreferences);this._init(conn);}).extend(Observable);Observable.defineObservableProperty(RoamingPreferenceManager.prototype,'preference',{readonly:true,value:null});RoamingPreferenceManager.prototype._init=function(conn){this._conn.getRoamingPreference().then((preference)=>{this._preference=preference;}).catch((error)=>{this.error('_init: could not retrieve roaming preference type: '+error);});};RoamingPreferenceManager.prototype.setRoamingPreference=function(pref){return this._conn.setRoamingPreference(pref).then(()=>{this._settingsHelper.get((values)=>{values[this._serviceId]=pref;this._settingsHelper.set(values);});this._preference=pref;},(error)=>{this.error('setRoamingPreference: '+error);});};return RoamingPreferenceManager;});define('panels/operator_settings/models/operator_item',['require','modules/base/module','modules/mvvm/observable'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');const STATE={IDLE:'idle',CONNECTING:'connecting',CONNECTED:'connected',FAILED:'failed'};const TYPE={AVAILABLE:'available',FORBIDDEN:'forbidden',UNKNOWN:'unknown'};var OperatorItem=Module.create(function OperatorItem(network){this.super(Observable).call(this);this._network=network;this._name=network.shortName||network.longName;switch(network.state){case'connected':case'current':this._state=STATE.CONNECTED;this._type=TYPE.AVAILABLE;break;case'available':this._state=STATE.IDLE;this._type=TYPE.AVAILABLE;break;case'forbidden':this._state=STATE.IDLE;this._type=TYPE.FORBIDDEN;break;default:this._state=STATE.IDLE;this._type=TYPE.UNKNOWN;break;}
this.observe('state',this._updateInfo.bind(this));this._updateInfo();}).extend(Observable);Object.defineProperty(OperatorItem,'STATE',{get:function(){return STATE;}});Object.defineProperty(OperatorItem,'TYPE',{get:function(){return TYPE;}});Object.defineProperty(OperatorItem.prototype,'name',{get:function(){return this._name;}});Object.defineProperty(OperatorItem.prototype,'network',{get:function(){return this._network;}});Observable.defineObservableProperty(OperatorItem.prototype,'state',{readonly:true,value:null});Observable.defineObservableProperty(OperatorItem.prototype,'info',{readonly:true,value:''});OperatorItem.prototype.setState=function oi_setState(state){this._state=state;};OperatorItem.prototype._updateInfo=function oi__updateInfo(){this._info=this._state===STATE.IDLE?this._type:this._state;this._info=this._info||TYPE.UNKNOWN;};return OperatorItem;});define('panels/operator_settings/models/mobile_connection_wrapper',['require','modules/base/module','modules/mvvm/observable'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');const STATE={IDLE:0,BUSY:1};function Task(promise){var canceled=false;var task=new Promise((resolve,reject)=>{promise.then((result)=>{if(!canceled){resolve(result);}else{reject('canceled');}},(error)=>{if(!canceled){reject(error);}else{reject('canceled');}});});task.cancel=function(){canceled=true;};return task;}
var Wrapper=Module.create(function MobileConnetionWrapper(conn){this.super(Observable).call(this);this._conn=conn;this._curSearch=null;this._state=STATE.IDLE;}).extend(Observable);Object.defineProperty(Wrapper,'STATE',{get:function(){return STATE;}});Observable.defineObservableProperty(Wrapper.prototype,'state',{readonly:true});Object.defineProperty(Wrapper.prototype,'networkSelectionMode',{get:function(){return this._conn.networkSelectionMode;}});Wrapper.prototype.search=function mcw_search(){this.debug('search');if(this._state!==STATE.IDLE){this.error('mobile connection is busy');return Promise.reject('busy');}
this._state=STATE.BUSY;this._curSearch=Task(this._conn.getNetworks());return this._curSearch.then((networks)=>{this.debug('search completed');this._state=STATE.IDLE;return networks;}).catch((error)=>{this._state=STATE.IDLE;if(error==='canceled'){this.debug('search canceled');}else{this.debug('search error: '+error);}
return Promise.reject(error);});};Wrapper.prototype.stop=function mcw_stop(){this.debug('stop');if(this._curSearch){this._curSearch.cancel();this._curSearch=null;}};Wrapper.prototype.connect=function mcw_connect(network){this.debug('connect');if(this._state!==STATE.IDLE){return Promise.reject('busy');}
this._state=STATE.BUSY;return this._conn.selectNetwork(network).then(()=>{this.debug('select network succeed');this._state=STATE.IDLE;}).catch((error)=>{this.debug('select network error: '+error);this._state=STATE.IDLE;return Promise.reject(error);});};Wrapper.prototype.setAutoSelection=function mcw_setAutoSelection(){this.debug('setAutoSelection');if(this._state!==STATE.IDLE){return Promise.reject('busy');}
this._state=STATE.BUSY;return this._conn.selectNetworkAutomatically().then(()=>{this.debug('setAutoSelection succeed');this._state=STATE.IDLE;}).catch((error)=>{this.debug('setAutoSelection error: '+error);this._state=STATE.IDLE;return Promise.reject(error);});};return Wrapper;});define('panels/operator_settings/models/auto_selection_model',['require','modules/defer','modules/state_model','panels/operator_settings/models/mobile_connection_wrapper'],function(require){'use strict';var Defer=require('modules/defer');var StateModel=require('modules/state_model');var MobileConnectionWrapper=require('panels/operator_settings/models/mobile_connection_wrapper');const AS_STATE={UNKNOWN:0,ENABLED:1,DISABLED:2};const AS_STATE_MAP={'manual':AS_STATE.DISABLED,'automatic':AS_STATE.ENABLED};var AutoSelectionModel=function(connWrapper){return StateModel({onInit:function(){this._pendingRequest=null;connWrapper.observe('state',(newState)=>{this._checkPendingRequest(newState);});return AS_STATE_MAP[connWrapper.networkSelectionMode]||AS_STATE.UNKNOWN;},onGetState:function(){return Promise.resolve(AS_STATE_MAP[connWrapper.networkSelectionMode]||AS_STATE.UNKNOWN);},onSetState:function(state){switch(connWrapper.state){case MobileConnectionWrapper.STATE.IDLE:if(state===AS_STATE.ENABLED){return connWrapper.setAutoSelection().then(()=>{return AS_STATE.ENABLED;},()=>{return Promise.reject(AS_STATE_MAP[connWrapper.networkSelectionMode]);});}else{return Promise.resolve(AS_STATE.DISABLED);}
break;case MobileConnectionWrapper.STATE.BUSY:return this._getPendingRequest(state).promise;}},_getPendingRequest:function(state){if(!this._pendingRequest){this._pendingRequest=Defer();}
this._pendingRequest.state=state;return this._pendingRequest;},_checkPendingRequest:function(newState){var pendingRequest=this._pendingRequest;if(newState!==MobileConnectionWrapper.STATE.IDLE||pendingRequest===null){return;}
this._pendingRequest=null;switch(pendingRequest.state){case AS_STATE.ENABLED:connWrapper.setAutoSelection().then(()=>{pendingRequest.resolve(AS_STATE.ENABLED);},()=>{pendingRequest.reject(AS_STATE_MAP[connWrapper.networkSelectionMode]);});break;case AS_STATE.DISABLED:pendingRequest.resolve(AS_STATE.DISABLED);break;}}});};Object.defineProperty(AutoSelectionModel,'STATE',{get:function(){return AS_STATE;}});return AutoSelectionModel;});define('panels/operator_settings/models/operator_manager',['require','modules/base/module','modules/mvvm/observable','modules/mvvm/observable_array','panels/operator_settings/models/operator_item','panels/operator_settings/models/mobile_connection_wrapper','panels/operator_settings/models/auto_selection_model'],function(require){'use strict';var Module=require('modules/base/module');var Observable=require('modules/mvvm/observable');var ObservableArray=require('modules/mvvm/observable_array');var OperatorItem=require('panels/operator_settings/models/operator_item');var MobileConnectionWrapper=require('panels/operator_settings/models/mobile_connection_wrapper');var AutoSelectionModel=require('panels/operator_settings/models/auto_selection_model');const RECONNECT_TIMEOUT=5000;var OperatorManager=Module.create(function OperatorManager(conn){this.super(Observable).call(this);this._connWrapper=MobileConnectionWrapper(conn);this._operators=ObservableArray();this._autoSelectionModel=AutoSelectionModel(this._connWrapper);this._autoSelectionState=this._autoSelectionModel.targetState;this._autoSelectionModel.observe('targetState',(newState)=>{this._autoSelectionState=newState;});this.observe('_autoSelectionState',(newState)=>{this._autoSelectionModel.targetState=newState;});this.observe('_autoSelectionState',(newState)=>{if(newState===AutoSelectionModel.STATE.ENABLED){this._connectedOperatorItem=null;}else if(newState===AutoSelectionModel.STATE.DISABLED){this.search();}});this._connecting=false;this._connectedOperatorItem=null;}).extend(Observable);Object.defineProperty(OperatorManager,'AUTO_SELECTION_STATE',{get:function(){return AutoSelectionModel.STATE;}});Object.defineProperty(OperatorManager.prototype,'operators',{get:function(){return this._operators;}});Observable.defineObservableProperty(OperatorManager.prototype,'autoSelectionState',{readonly:true,value:null});Observable.defineObservableProperty(OperatorManager.prototype,'connectedOperatorItem',{readonly:true,value:null});Observable.defineObservableProperty(OperatorManager.prototype,'searching',{readonly:true,value:false});OperatorManager.prototype.search=function(){if(this._searching){return Promise.resolve();}
this.debug('search');this._searching=true;return this._connWrapper.search().then((networks)=>{networks=networks||[];var operators=networks.map((network)=>OperatorItem(network));operators.forEach((operator)=>{if(operator.network.state===OperatorItem.STATE.CONNECTED){this._connectedOperatorItem=operator;}});this._operators.reset(operators);}).catch((error)=>{if(error!=='busy'){this._operators.reset([]);}
this.error('could not retrieve any network operator: '+error);}).then(()=>{this._searching=false;});};OperatorManager.prototype.stop=function(){this._connWrapper.stop();this._searching=false;};OperatorManager.prototype.connect=function(operatorItem){if(this._connecting||operatorItem===this._connectedOperatorItem){return Promise.resolve();}
this.debug('connect');this._connecting=true;operatorItem.setState(OperatorItem.STATE.CONNECTING);return this._connWrapper.connect(operatorItem.network).then(()=>{operatorItem.setState(OperatorItem.STATE.CONNECTED);this._connectedOperatorItem=operatorItem;}).catch((error)=>{this.error('unable to connect to the network: '+error);operatorItem.setState(OperatorItem.STATE.FAILED);setTimeout(function(originalOperatorItem){operatorItem.setState(OperatorItem.STATE.IDLE);if(originalOperatorItem&&this.autoSelectionState===AutoSelectionModel.STATE.DISABLED){this.connect(originalOperatorItem);}}.bind(this,this._connectedOperatorItem),RECONNECT_TIMEOUT);}).then(()=>{this._connecting=false;});};OperatorManager.prototype.setAutoSelection=function(enabled){this.debug('setAutoSelection: '+enabled);this._autoSelectionModel.targetState=enabled?AutoSelectionModel.STATE.ENABLED:AutoSelectionModel.STATE.DISABLED;};return OperatorManager;});define('panels/operator_settings/views/network_type_item_template',['require'],function(require){'use strict';function Template(networkTypeMap,networkType,recycled){var container=null;if(recycled){container=recycled;}else{container=document.createElement('option');}
container.value=networkType;var textInfo=networkTypeMap(networkType);if(textInfo.l10nId){container.setAttribute('data-l10n-id',textInfo.l10nId);}else if(textInfo.text){container.textContent=textInfo.text;}else{container.textContent=networkType;}
return container;}
return function TemplateFactory(networkTypeMap){return Template.bind(null,networkTypeMap);};});define('panels/operator_settings/views/network_type_selector',['require','modules/dialog_service','modules/base/module','modules/customized_network_type_map','modules/mvvm/list_view','panels/operator_settings/views/network_type_item_template'],function(require){'use strict';var DialogService=require('modules/dialog_service');var Module=require('modules/base/module');var CustomizedNetworkTypeMap=require('modules/customized_network_type_map');var ListView=require('modules/mvvm/list_view');var NetworkTypeItemTemplate=require('panels/operator_settings/views/network_type_item_template');var NetworkTypeSelector=Module.create(function NetworkTypeSelector(root){this._root=root;this._manager=null;this._customizedNetworkTypeMap=null;this._networkTypeMap=null;var networkTypeItemTemplate=NetworkTypeItemTemplate(this._getTextInfoForNetworkType.bind(this));this._networkTypeOptions=ListView(this._root,null,networkTypeItemTemplate);this._root.addEventListener('blur',()=>{this._manager.setPreferredNetworkType(this._root.value).catch(()=>{DialogService.alert('preferredNetworkTypeAlertErrorMessage',{title:'preferredNetworkTypeAlertTitle'});});});this._boundUpdateSelector=this._updateSelector.bind(this);});NetworkTypeSelector.prototype._getTextInfoForNetworkType=function(type){if(this._customizedNetworkTypeMap&&type in this._customizedNetworkTypeMap){return{text:this._customizedNetworkTypeMap[type]};}else if(this._networkTypeMap){return{l10nId:this._networkTypeMap(type)};}else{return type;}};NetworkTypeSelector.prototype._updateSelector=function(type){this._root.value=type;};NetworkTypeSelector.prototype.init=function(networkTypeManager){this._manager=networkTypeManager;if(!this._manager){return;}
return CustomizedNetworkTypeMap.get().then((customizedMap)=>{this._customizedNetworkTypeMap=customizedMap;}).then(()=>{return this._manager.getSupportedNetworkInfo();}).then((info)=>{this._networkTypeMap=info.l10nIdForType;this._networkTypeOptions.set(this._manager.networkTypes);this._networkTypeOptions.enabled=true;this._manager.observe('preferredNetworkType',this._boundUpdateSelector);this._updateSelector(this._manager.preferredNetworkType);});};NetworkTypeSelector.prototype.uninit=function(){if(!this._manager){return;}
this._manager.unobserve('preferredNetworkType',this._boundUpdateSelector);this._networkTypeOptions.set(null);this._networkTypeOptions.enabled=false;this._manager=null;};return NetworkTypeSelector;});define('panels/operator_settings/views/roaming_preference_selector',['require','modules/base/module'],function(require){'use strict';var Module=require('modules/base/module');var RoamingPreferenceSelector=Module.create(function RoamingPreferenceSelector(root){this._root=root;this._manager=null;this._root.addEventListener('blur',()=>{this._manager.setRoamingPreference(this._root.value);});this._boundUpdateSelector=this._updateSelector.bind(this);});RoamingPreferenceSelector.prototype._updateSelector=function(preference){this._root.value=preference;};RoamingPreferenceSelector.prototype.init=function(manager){this._manager=manager;if(!this._manager){return;}
this._manager.observe('preference',this._boundUpdateSelector);this._boundUpdateSelector(this._manager.preference);};RoamingPreferenceSelector.prototype.uninit=function(){if(!this._manager){return;}
this._manager.unobserve('preference',this._boundUpdateSelector);this._manager=null;};return RoamingPreferenceSelector;});define('panels/operator_settings/views/auto_selection_checkbox',['require','modules/base/module','panels/operator_settings/models/operator_manager'],function(require){'use strict';var Module=require('modules/base/module');var OperatorManager=require('panels/operator_settings/models/operator_manager');var AutoSelectionCheckbox=Module.create(function AutoSelectionCheckbox(root){this._root=root;this._manager=null;this._root.addEventListener('change',()=>{this._manager.setAutoSelection(this._root.checked);});this._boundUpdate=this._update.bind(this);});AutoSelectionCheckbox.prototype._update=function(state){this._root.checked=state===OperatorManager.AUTO_SELECTION_STATE.ENABLED||state===OperatorManager.AUTO_SELECTION_STATE.ENABLING;};AutoSelectionCheckbox.prototype.init=function(manager){this._manager=manager;if(!this._manager){return;}
this._manager.observe('autoSelectionState',this._boundUpdate);this._boundUpdate(this._manager.autoSelectionState);};AutoSelectionCheckbox.prototype.uninit=function(){if(!this._manager){return;}
this._manager.unobserve('autoSelectionState',this._boundUpdate);this._manager=null;};return AutoSelectionCheckbox;});define('panels/operator_settings/views/operator_item_template',['require'],function(require){'use strict';function OperatorItemTemplate(onItemClick,operatorItem,recycled){var container=null;var name;var info;var link;if(recycled){container=recycled;name=container.querySelector('span');info=container.querySelector('small');link=container.querySelector('a');}else{name=document.createElement('span');info=document.createElement('small');link=document.createElement('a');container=document.createElement('li');link.appendChild(name);link.appendChild(info);container.appendChild(link);container.classList.add('operatorItem');}
name.textContent=operatorItem.name;operatorItem.observe('info',function(){info.setAttribute('data-l10n-id','operator-info-'+operatorItem.info);});info.setAttribute('data-l10n-id','operator-info-'+operatorItem.info);if(typeof onItemClick==='function'){container.onclick=function(){onItemClick(operatorItem);};}
return container;}
return function OperatorItemTemplateFactory(onItemClick){return OperatorItemTemplate.bind(null,onItemClick);};});define('panels/operator_settings/views/available_operator_list',['require','modules/mvvm/list_view','panels/operator_settings/models/operator_manager','panels/operator_settings/views/operator_item_template'],function(require){'use strict';var ListView=require('modules/mvvm/list_view');var OperatorManager=require('panels/operator_settings/models/operator_manager');var OperatorItemTemplate=require('panels/operator_settings/views/operator_item_template');function AvailableOperatorList(root){this._operatorManager=null;this._root=root;this._elements={operatorListRoot:root.querySelector('.available-operators-list'),searchBtnListItem:root.querySelector('.search-btn-li'),searchBtn:root.querySelector('.search-btn'),operatorListInfo:root.querySelector('.search-info')};this._operatorListView=ListView(this._elements.operatorListRoot,null,OperatorItemTemplate((operatorItem)=>{this._operatorManager.connect(operatorItem);}));this._elements.searchBtn.addEventListener('click',()=>{this._operatorManager.search();});this._boundUpdateVisibility=this._updateVisibility.bind(this);this._boundUpdateInfo=this._updateInfo.bind(this);}
AvailableOperatorList.prototype.init=function(operatorManager){this._operatorManager=operatorManager;if(!this._operatorManager){return;}
this._operatorManager.observe('autoSelectionState',this._boundUpdateVisibility);this._boundUpdateVisibility(this._operatorManager.autoSelectionState);this._operatorManager.observe('autoSelectionState',this._boundUpdateInfo);this._operatorManager.observe('searching',this._boundUpdateInfo);this._boundUpdateInfo();this._operatorListView.set(this._operatorManager.operators);this._operatorListView.enabled=true;};AvailableOperatorList.prototype.uninit=function(){if(!this._operatorManager){return;}
this._operatorManager.unobserve('autoSelectionState',this._boundUpdateVisibility);this._operatorManager.unobserve('autoSelectionState',this._boundUpdateInfo);this._operatorManager.unobserve('searching',this._boundUpdateInfo);this._operatorListView.set(null);this._operatorListView.enabled=false;this._operatorManager=null;};AvailableOperatorList.prototype._updateVisibility=function(autoSelectionState){switch(autoSelectionState){case OperatorManager.AUTO_SELECTION_STATE.ENABLED:this._elements.operatorListRoot.hidden=true;this._elements.searchBtnListItem.hidden=true;break;case OperatorManager.AUTO_SELECTION_STATE.DISABLED:this._elements.operatorListRoot.hidden=false;this._elements.searchBtnListItem.hidden=false;break;}};AvailableOperatorList.prototype._updateInfo=function(){switch(this._operatorManager.autoSelectionState){case OperatorManager.AUTO_SELECTION_STATE.ENABLED:this._elements.operatorListInfo.hidden=false;this._elements.operatorListInfo.setAttribute('data-l10n-id','operator-turnAutoSelectionOff');break;case OperatorManager.AUTO_SELECTION_STATE.DISABLED:if(this._operatorManager.searching){this._elements.operatorListInfo.hidden=false;this._elements.operatorListInfo.setAttribute('data-l10n-id','scanning');}else{this._elements.operatorListInfo.hidden=true;}
break;}};return function(root){return new AvailableOperatorList(root);};});define('panels/operator_settings/panel',['require','modules/settings_panel','dsds_settings','panels/operator_settings/models/panel_model','panels/operator_settings/models/network_type_manager','panels/operator_settings/models/roaming_preference_manager','panels/operator_settings/models/operator_manager','panels/operator_settings/views/network_type_selector','panels/operator_settings/views/roaming_preference_selector','panels/operator_settings/views/auto_selection_checkbox','panels/operator_settings/views/available_operator_list'],function(require){'use strict';var SettingsPanel=require('modules/settings_panel');var DsdsSettings=require('dsds_settings');var PanelModel=require('panels/operator_settings/models/panel_model');var NetworkTypeManager=require('panels/operator_settings/models/network_type_manager');var RoamingPreferenceManager=require('panels/operator_settings/models/roaming_preference_manager');var OperatorManager=require('panels/operator_settings/models/operator_manager');var NetworkTypeSelector=require('panels/operator_settings/views/network_type_selector');var RoamingPreferenceSelector=require('panels/operator_settings/views/roaming_preference_selector');var AutoSelectionCheckbox=require('panels/operator_settings/views/auto_selection_checkbox');var AvailableOperatorList=require('panels/operator_settings/views/available_operator_list');return function(){return SettingsPanel({onInit:function(panel){this._panel=panel;this._elements={header:panel.querySelector('gaia-header'),networkTypeSelector:panel.querySelector('.preferred-network-type select'),roamingPreferenceMenuItem:panel.querySelector('.operator-roaming-preference'),roamingPreferenceSelector:panel.querySelector('.operator-roaming-preference select'),autoSelectionMenuItem:panel.querySelector('.auto-select'),autoSelectionCheckbox:panel.querySelector('.auto-select gaia-switch'),availableOperators:panel.querySelector('.available-operators')};if(navigator.mozMobileConnections.length>1){this._elements.header.dataset.href='#carrier-detail';}else{this._elements.header.dataset.href='#carrier';}
this._networkTypeSelector=NetworkTypeSelector(this._elements.networkTypeSelector);this._roamingPreferenceSelector=RoamingPreferenceSelector(this._elements.roamingPreferenceSelector);this._autoSelectionCheckbox=AutoSelectionCheckbox(this._elements.autoSelectionCheckbox);this._availableOperatorList=AvailableOperatorList(this._elements.availableOperators);this._boundOnConnectingModeChange=this._onConnectingModeChange.bind(this);},onBeforeShow:function(panel){var serviceId=DsdsSettings.getIccCardIndexForCellAndDataSettings();var panelModel=this._getInstance(PanelModel,serviceId);var operatorManager=this._getInstance(OperatorManager,serviceId);var roamingPreferenceManager=this._getInstance(RoamingPreferenceManager,serviceId);var networkTypeManager=this._getInstance(NetworkTypeManager,serviceId);this._setPanelModel(panelModel);this._availableOperatorList.init(operatorManager);this._roamingPreferenceSelector.init(roamingPreferenceManager);this._autoSelectionCheckbox.init(operatorManager);return this._networkTypeSelector.init(networkTypeManager);},onHide:function(){this._setPanelModel(null);this._networkTypeSelector.uninit();this._roamingPreferenceSelector.uninit();this._autoSelectionCheckbox.uninit();this._availableOperatorList.uninit();},_getInstance:function(ctor,serviceId){if(!this._instances){this._instances=new Map();}
if(!this._instances.has(ctor)){this._instances.set(ctor,{});}
var instance=this._instances.get(ctor)[serviceId];if(!instance){var conn=navigator.mozMobileConnections[serviceId];instance=ctor(conn);this._instances.get(ctor)[serviceId]=instance;}
return instance;},_setPanelModel:function(panelModel){if(this._panelModel){this._panelModel.unobserve('connectingMode',this._boundOnConnectingModeChange);}
this._panelModel=panelModel;if(this._panelModel){this._panelModel=panelModel;panelModel.observe('connectingMode',this._boundOnConnectingModeChange);this._onConnectingModeChange(panelModel.connectingMode);}},_onConnectingModeChange:function(mode){this._elements.roamingPreferenceMenuItem.hidden=(mode!=='cdma');this._elements.autoSelectionMenuItem.hidden=this._elements.availableOperators.hidden=(mode!=='gsm');}});};});