;;'use strict';(function(exports){var PromiseStorage=function(name){this.name=name;if(typeof this.name!=='string'||this.name===''){throw new Error('PromiseStorage: Need a storage name.');}
this._openPromise=null;};PromiseStorage.prototype.DB_VERSION=1;PromiseStorage.prototype.STORE_NAME='keyvaluepairs';PromiseStorage.prototype.start=function(){return this._getDatabase().catch(function(e){this._openPromise=null;throw e;}.bind(this));};PromiseStorage.prototype.stop=function(){if(!this._openPromise){return Promise.resolve();}
return this._getDatabase().then(function(db){db.close();this._openPromise=null;});};PromiseStorage.prototype._getDatabase=function(){if(this._openPromise){return this._openPromise;}
var p=new Promise(function(resolve,reject){var req=window.indexedDB.open(this.name,this.DB_VERSION);req.onerror=function(){reject(req.error);};req.onsuccess=function(evt){resolve(req.result);};req.onupgradeneeded=function(evt){var db=req.result;if(evt.oldVersion<1){db.createObjectStore(this.STORE_NAME);}}.bind(this);}.bind(this));this._openPromise=p;return p;};PromiseStorage.prototype._getTxn=function(type,callback){return this._getDatabase().then(function(db){var txn=db.transaction(this.STORE_NAME,type);return callback(txn);}.bind(this));};PromiseStorage.prototype.getItems=function(names){return this._getTxn('readonly',function(txn){var store=txn.objectStore(this.STORE_NAME);var reqPromises=names.map(function(name){return new Promise(function(resolve,reject){var req=store.get(name);req.onerror=function(e){reject(req.error);};req.onsuccess=function(){resolve(req.result);};});},this);return new Promise(function(resolve){txn.oncomplete=function(){resolve(Promise.all(reqPromises));};});}.bind(this)).catch(function(e){e&&console.error(e);return Promise.reject(e);});};PromiseStorage.prototype.getItem=function(name){return this._getTxn('readonly',function(txn){return new Promise(function(resolve,reject){var req=txn.objectStore(this.STORE_NAME).get(name);req.onerror=function(e){reject(req.error);};txn.oncomplete=function(){resolve(req.result);};}.bind(this));}.bind(this)).catch(function(e){e&&console.error(e);return Promise.reject(e);});};PromiseStorage.prototype.setItem=function(name,data){return this._getTxn('readwrite',function(txn){return new Promise(function(resolve,reject){var store=txn.objectStore(this.STORE_NAME);var req=store.put(data,name);req.onerror=function(e){reject(req.error);};txn.oncomplete=function(){resolve(req.result);};}.bind(this));}.bind(this)).catch(function(e){e&&console.error(e);return Promise.reject(e);});};PromiseStorage.prototype.setItems=function(items){return this._getTxn('readwrite',function(txn){var store=txn.objectStore(this.STORE_NAME);var reqPromises=Object.keys(items).map(function(name){var data=items[name];return new Promise(function(resolve,reject){var req=store.put(data,name);req.onerror=function(e){reject(req.error);};req.onsuccess=function(){resolve(req.result);};});},this);return new Promise(function(resolve){txn.oncomplete=function(){resolve(Promise.all(reqPromises));};});}.bind(this)).catch(function(e){e&&console.error(e);return Promise.reject(e);});};PromiseStorage.prototype.deleteItem=function(name){return this._getTxn('readwrite',function(txn){return new Promise(function(resolve,reject){var req=txn.objectStore(this.STORE_NAME).delete(name);req.onerror=function(e){reject(req.error);};txn.oncomplete=function(){resolve();};}.bind(this));}.bind(this)).catch(function(e){e&&console.error(e);return Promise.reject(e);});};exports.PromiseStorage=PromiseStorage;}(window));